unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, opengl,
  ExtCtrls, glbmp, math;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer2Timer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
   myDC : HDC;
   myRC : HGLRC;
   myPalette : HPALETTE;
   procedure SetupPixelFormat;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  floor, light, top, wall1, wall2, light1, light2, light3, light4 : Tglbmp;
  my_x : double = 0;
  my_y : double = 0;
  rot : double = 0;
  rdir : byte = 0;
  timefactor : double = 1;
  fps : integer = 20;
  lichtan : boolean = false;
  xs,ys : integer;



const 
  schalter = 1;
  umgebung = 2;
  

implementation

{$R *.DFM}
procedure TForm1.SetupPixelFormat;
var    hHeap: THandle;
  nColors, i: Integer;
  lpPalette : PLogPalette;
  byRedMask, byGreenMask, byBlueMask: Byte;
  nPixelFormat: Integer;
  pfd: TPixelFormatDescriptor;
begin
  FillChar(pfd, SizeOf(pfd), 0);
  with pfd do begin
    nSize     := sizeof(pfd);               // Lnge der pfd-Struktur
    nVersion  := 1;                         // Version
    dwFlags   := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or
                 PFD_DOUBLEBUFFER;          // Flags
    iPixelType:= PFD_TYPE_RGBA;             // RGBA Pixel Type
    cColorBits:= 24;                        // 24-bit color
    cDepthBits:= 32;                        // 32-bit depth buffer
    iLayerType:= PFD_MAIN_PLANE;            // Layer Type
  end;
  nPixelFormat:= ChoosePixelFormat(myDC, @pfd);
  SetPixelFormat(myDC, nPixelFormat, @pfd);
                                            // Farbpalettenoptimierung wenn erforderlich
  DescribePixelFormat(myDC, nPixelFormat,
                      sizeof(TPixelFormatDescriptor),pfd);
  if ((pfd.dwFlags and PFD_NEED_PALETTE) <> 0) then begin
    nColors  := 1 shl pfd.cColorBits;
    hHeap    := GetProcessHeap;
    lpPalette:= HeapAlloc
       (hHeap,0,sizeof(TLogPalette)+(nColors*sizeof(TPaletteEntry)));
    lpPalette^.palVersion := $300;
    lpPalette^.palNumEntries := nColors;
    byRedMask  := (1 shl pfd.cRedBits) - 1;
    byGreenMask:= (1 shl pfd.cGreenBits) - 1;
    byBlueMask := (1 shl pfd.cBlueBits) - 1;
    for i := 0 to nColors - 1 do begin
      lpPalette^.palPalEntry[i].peRed  :=
        (((i shr pfd.cRedShift)  and byRedMask)  *255)DIV byRedMask;
      lpPalette^.palPalEntry[i].peGreen:=
        (((i shr pfd.cGreenShift)and byGreenMask)*255)DIV byGreenMask;
      lpPalette^.palPalEntry[i].peBlue :=
        (((i shr pfd.cBlueShift) and byBlueMask) *255)DIV byBlueMask;
      lpPalette^.palPalEntry[i].peFlags:= 0;
    end;
    myPalette:= CreatePalette(lpPalette^);
    HeapFree(hHeap, 0, lpPalette);
    if (myPalette <> 0) then begin
      SelectPalette(myDC, myPalette, False);
      RealizePalette(myDC);
    end;
  end;
end;

procedure inittextures;
begin
floor := Tglbmp.create;
floor.LoadImage('Texturen/floor.jpg');
floor.GenTexture;

light := Tglbmp.create;
light.LoadImage('Texturen/light.jpg');
light.GenTexture;

wall1 := Tglbmp.create;
wall1.LoadImage('Texturen/wall.jpg');
wall1.GenTexture;

wall2 := Tglbmp.create;
wall2.LoadImage('Texturen/wall2.jpg');
wall2.GenTexture;

top := Tglbmp.create;
top.LoadImage('Texturen/top.jpg');
top.GenTexture;

light1 := Tglbmp.create;
light1.LoadImage('Texturen/light1.jpg');
light1.GenTexture;

light2 := Tglbmp.create;
light2.LoadImage('Texturen/light2.jpg');
light2.GenTexture;

light3 := Tglbmp.create;
light3.LoadImage('Texturen/light3.jpg');
light3.GenTexture;

light4 := Tglbmp.create;
light4.LoadImage('Texturen/light4.jpg');
light4.GenTexture;
end;

procedure draw_raum1;
begin
floor.bind;
gldepthmask(gl_false);
glbegin(gl_quads);
gltexcoord2f(0,0);             // Raum1 Fuboden
glvertex3f(-4,0,8);
gltexcoord2f(8,0);
glvertex3f(4,0,8);
gltexcoord2f(8,16);
glvertex3f(4,0,-8);
gltexcoord2f(0,16);
glvertex3f(-4,0,-8);
glend;

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
gldepthmask(gl_true);
light1.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);             // Raum1 Fuboden-Licht
glvertex3f(-4,0,8);
gltexcoord2f(1,0);
glvertex3f(4,0,8);
gltexcoord2f(1,2);
glvertex3f(4,0,-8);
gltexcoord2f(0,2);
glvertex3f(-4,0,-8);
glend;
gldisable(gl_blend);

gldepthmask(gl_false);
wall1.Bind;
glbegin(gl_quads);            //Wand Hinten
gltexcoord2f(0,0);
glvertex3f(-4,0,-8);
gltexcoord2f(8,0);
glvertex3f(4,0,-8);
gltexcoord2f(8,1);
glvertex3f(4,2,-8);
gltexcoord2f(0,1);
glvertex3f(-4,2,-8);
glend;
gldepthmask(gl_true);


glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
light2.bind;
glbegin(gl_quads);            //Raum1 Wand Hinten-Licht
gltexcoord2f(0,0);
glvertex3f(-4,0,-8);
gltexcoord2f(1,0);
glvertex3f(4,0,-8);
gltexcoord2f(1,1);
glvertex3f(4,2,-8);
gltexcoord2f(0,1);
glvertex3f(-4,2,-8);
glend;
gldisable(gl_blend);

wall1.bind;                  //Raum1 Wand Vorne
gldepthmask(gl_false);
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(-4,0,8);
gltexcoord2f(8,0);
glvertex3f(4,0,8);
gltexcoord2f(8,1);
glvertex3f(4,2,8);
gltexcoord2f(0,1);
glvertex3f(-4,2,8);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
light2.bind;
glbegin(gl_quads);          // Raum1 Wand Vorne-Licht
gltexcoord2f(0,0);
glvertex3f(-4,0,8);
gltexcoord2f(1,0);
glvertex3f(4,0,8);
gltexcoord2f(1,1);
glvertex3f(4,2,8);
gltexcoord2f(0,1);
glvertex3f(-4,2,8);
glend;
gldisable(gl_blend);

gldepthmask(gl_false);
wall1.bind;                //Raum1 Wand Links
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(-4,0,-8);
gltexcoord2f(16,0);
glvertex3f(-4,0,8);
gltexcoord2f(16,1);
glvertex3f(-4,2,8);
gltexcoord2f(0,1);
glvertex3f(-4,2,-8);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
light2.bind;
glbegin(gl_quads);          // Raum1 Wand Links-Licht
gltexcoord2f(0,0);
glvertex3f(-4,0,-8);
gltexcoord2f(2,0);
glvertex3f(-4,0,8);
gltexcoord2f(2,1);
glvertex3f(-4,2,8);
gltexcoord2f(0,1);
glvertex3f(-4,2,-8);
glend;
gldisable(gl_blend);

gldepthmask(gl_false);
wall1.bind;              //Raum1 Wand Rechts
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(4,0,-4);
gltexcoord2f(12,0);
glvertex3f(4,0,8);
gltexcoord2f(12,1);
glvertex3f(4,2,8);
gltexcoord2f(0,1);
glvertex3f(4,2,-4);
                   
gltexcoord2f(0,0);           //Raum1 Wand Rechts II
glvertex3f(4,0,-7);
gltexcoord2f(1,0);
glvertex3f(4,0,-8);
gltexcoord2f(1,1);
glvertex3f(4,2,-8);
gltexcoord2f(0,1);
glvertex3f(4,2,-7);
glend;
gldepthmask(gl_true);


glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
light2.bind;
glbegin(gl_quads);          // Raum1 Wand RechtsI-Licht
gltexcoord2f(0,0);
glvertex3f(4,0,-4);
gltexcoord2f(1.5,0);
glvertex3f(4,0,8);
gltexcoord2f(1.5,1);
glvertex3f(4,2,8);
gltexcoord2f(0,1);
glvertex3f(4,2,-4);

gltexcoord2f(0,0);         // Raum1 Wand RechtsII-Licht
glvertex3f(4,0,-7);
gltexcoord2f(0.875,0);
glvertex3f(4,0,-8);
gltexcoord2f(0.875,1);
glvertex3f(4,2,-8);
gltexcoord2f(0,1);
glvertex3f(4,2,-7);
glend;
gldisable(gl_blend);


gldepthmask(gl_false);
top.bind;
glbegin(gl_quads);           // Raum1 Decke
gltexcoord2f(0,0);             
glvertex3f(-4,2,8);
gltexcoord2f(8,0);
glvertex3f(4,2,8);
gltexcoord2f(8,16);
glvertex3f(4,2,-8);
gltexcoord2f(0,16);
glvertex3f(-4,2,-8);
glend;
gldepthmask(gl_true);


glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
gldepthmask(gl_true);
light1.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);             // Raum1 Decke-Licht
glvertex3f(-4,2,8);
gltexcoord2f(1,0);
glvertex3f(4,2,8);
gltexcoord2f(1,2);
glvertex3f(4,2,-8);
gltexcoord2f(0,2);
glvertex3f(-4,2,-8);
glend;
gldisable(gl_blend);

wall1.bind;                        //Lampe1 (Raum1)
glcolor3f(0.8,0.8,0.8);
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,-4.25);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-4.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,-4.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,-4.25);

gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,-3.75);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-3.75);
gltexcoord2f(1,1);
glvertex3f(0.25,2,-3.75);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,-3.75);

gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,-3.75);
gltexcoord2f(1,0);
glvertex3f(-0.25,1.95,-4.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,-4.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,-3.75);

gltexcoord2f(0,0);
glvertex3f(0.25,1.95,-3.75);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-4.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,-4.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,-3.75);
glend;

light.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(0.25,1.95,-3.75);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-4.25);
gltexcoord2f(1,2);
glvertex3f(-0.25,1.95,-4.25);
gltexcoord2f(0,2);
glvertex3f(-0.25,1.95,-3.75);
glend;



wall1.bind;                        //Lampe2 (Raum1)
glcolor3f(0.8,0.8,0.8);
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,4.25);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,4.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,4.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,4.25);

gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,3.75);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,3.75);
gltexcoord2f(1,1);
glvertex3f(0.25,2,3.75);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,3.75);

gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,3.75);
gltexcoord2f(1,0);
glvertex3f(-0.25,1.95,4.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,4.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,3.75);

gltexcoord2f(0,0);
glvertex3f(0.25,1.95,3.75);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,4.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,4.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,3.75);
glend;

light.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(0.25,1.95,3.75);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,4.25);
gltexcoord2f(1,2);
glvertex3f(-0.25,1.95,4.25);
gltexcoord2f(0,2);
glvertex3f(-0.25,1.95,3.75);
glend;

glcolor3f(1,1,1);
end;

procedure draw_verbindung;
begin
gldepthmask(gl_false);
floor.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);            //Zwischengang Fuboden
glvertex3f(4,0,-7);
gltexcoord2f(3,0);
glvertex3f(4,0,-4);
gltexcoord2f(3,3);
glvertex3f(7,0,-4);
gltexcoord2f(0,3);
glvertex3f(7,0,-7);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.8,0.8,0.8);
light3.bind;
end
else
begin
glcolor3f(0.8,0.8,0.8);
light4.bind;
end;
glbegin(gl_quads);
gltexcoord2f(0,0);            //Zwischengang Fuboden-Licht
glvertex3f(4,0,-7);
gltexcoord2f(1,0);
glvertex3f(4,0,-4);
gltexcoord2f(1,1);
glvertex3f(7,0,-4);
gltexcoord2f(0,1);
glvertex3f(7,0,-7);
glend;
gldisable(gl_blend);

wall1.bind;
gldepthmask(gl_false);        //Zwischengang Wand Vorne
glbegin(gl_quads);
gltexcoord2f(0,1);
glvertex3f(4,0,-4);
gltexcoord2f(0,0);
glvertex3f(4,2,-4);
gltexcoord2f(3,0);
glvertex3f(7,2,-4);
gltexcoord2f(3,1);
glvertex3f(7,0,-4);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.8,0.8,0.8);
light3.bind;
end
else
begin
glcolor3f(0.8,0.8,0.8);
light4.bind;
end;

glbegin(gl_quads);            //Zwischengang Wand Vorne-Licht
gltexcoord2f(0,0);
glvertex3f(4,0,-4);
gltexcoord2f(1,0);
glvertex3f(4,2,-4);
gltexcoord2f(1,1);
glvertex3f(7,2,-4);
gltexcoord2f(0,1);
glvertex3f(7,0,-4);
glend;
gldisable(gl_blend);


wall1.bind;
gldepthmask(gl_false);        //Zwischengang Wand Hinten
glbegin(gl_quads);
gltexcoord2f(0,1);
glvertex3f(4,0,-7);
gltexcoord2f(0,0);
glvertex3f(4,2,-7);
gltexcoord2f(3,0);
glvertex3f(7,2,-7);
gltexcoord2f(3,1);
glvertex3f(7,0,-7);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.8,0.8,0.8);
light3.bind;
end
else
begin
glcolor3f(0.8,0.8,0.8);
light4.bind;
end;

glbegin(gl_quads);            //Zwischengang Wand Hinten-Licht
gltexcoord2f(0,0);
glvertex3f(4,0,-7);
gltexcoord2f(1,0);
glvertex3f(4,2,-7);
gltexcoord2f(1,1);
glvertex3f(7,2,-7);
gltexcoord2f(0,1);
glvertex3f(7,0,-7);
glend;
gldisable(gl_blend);


gldepthmask(gl_false);
top.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);            //Zwischengang Decke
glvertex3f(4,2,-7);
gltexcoord2f(3,0);
glvertex3f(4,2,-4);
gltexcoord2f(3,3);
glvertex3f(7,2,-4);
gltexcoord2f(0,3);
glvertex3f(7,2,-7);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.8,0.8,0.8);
light3.bind;
end
else
begin
glcolor3f(0.8,0.8,0.8);
light4.bind;
end;
glbegin(gl_quads);
gltexcoord2f(0,0);            //Zwischengang Decke-Licht
glvertex3f(4,2,-7);
gltexcoord2f(1,0);
glvertex3f(4,2,-4);
gltexcoord2f(1,1);
glvertex3f(7,2,-4);
gltexcoord2f(0,1);
glvertex3f(7,2,-7);
glend;
gldisable(gl_blend);
end;

procedure draw_raum2;
begin
floor.bind;
gldepthmask(gl_false);
glbegin(gl_quads);
gltexcoord2f(0,0);           //Raum2 Fuboden
glvertex3f(7,0,-4);
gltexcoord2f(8,0);
glvertex3f(15,0,-4);
gltexcoord2f(8,8);
glvertex3f(15,0,-12);
gltexcoord2f(0,8);
glvertex3f(7,0,-12);
glend;
gldepthmask(gl_true);


glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.3,0.3,0.3);
light4.bind;
end
else
begin
glcolor3f(1,1,1);
light1.bind;
end;

glbegin(gl_quads);
gltexcoord2f(0,0);           //Raum2 Fuboden-Licht
glvertex3f(7,0,-4);
gltexcoord2f(1,0);
glvertex3f(15,0,-4);
gltexcoord2f(1,1);
glvertex3f(15,0,-12);
gltexcoord2f(0,1);
glvertex3f(7,0,-12);
glend;
gldisable(gl_blend);

glcolor3f(1,1,1);

gldepthmask(gl_false);
wall2.bind;
glbegin(gl_quads);                    //Raum2 Wand Vorne
gltexcoord2f(0,0);
glvertex3f(7,0,-4);
gltexcoord2f(8,0);
glvertex3f(15,0,-4);
gltexcoord2f(8,1);
glvertex3f(15,2,-4);
gltexcoord2f(0,1);
glvertex3f(7,2,-4);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.3,0.3,0.3);
light4.bind;
end
else
begin
glcolor3f(1,1,1);
light2.bind;
end;

glbegin(gl_quads);                     // Raum2 Wand Vorne-Licht
gltexcoord2f(0,0);
glvertex3f(7,0,-4);
gltexcoord2f(8,0);
glvertex3f(15,0,-4);
gltexcoord2f(8,1);
glvertex3f(15,2,-4);
gltexcoord2f(0,1);
glvertex3f(7,2,-4);
glend;

gldisable(gl_blend);
glcolor3f(1,1,1);

gldepthmask(gl_false);
wall2.bind;
glbegin(gl_quads);                    //Raum2 Wand Hinten
gltexcoord2f(0,0);
glvertex3f(7,0,-12);
gltexcoord2f(8,0);
glvertex3f(15,0,-12);
gltexcoord2f(8,1);
glvertex3f(15,2,-12);
gltexcoord2f(0,1);
glvertex3f(7,2,-12);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.3,0.3,0.3);
light4.bind;
end
else
begin
glcolor3f(1,1,1);
light2.bind;
end;

glbegin(gl_quads);                     // Raum2 Wand Hinten-Licht
gltexcoord2f(0,0);
glvertex3f(7,0,-12);
gltexcoord2f(8,0);
glvertex3f(15,0,-12);
gltexcoord2f(8,1);
glvertex3f(15,2,-12);
gltexcoord2f(0,1);
glvertex3f(7,2,-12);
glend;

gldisable(gl_blend);
glcolor3f(1,1,1);

wall2.bind;
gldepthmask(gl_false);
glbegin(gl_quads);               // Raum2 Wand Links
gltexcoord2f(0,0);
glvertex3f(7,0,-7);
gltexcoord2f(5,0);
glvertex3f(7,0,-12);
gltexcoord2f(5,1);
glvertex3f(7,2,-12);
gltexcoord2f(0,1);
glvertex3f(7,2,-7);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.3,0.3,0.3);
light4.bind;
end
else
begin
glcolor3f(1,1,1);
light2.bind;
end;

glbegin(gl_quads);               // Raum2 Wand Links-Licht
gltexcoord2f(0.375,0);
glvertex3f(7,0,-7);
gltexcoord2f(1,0);
glvertex3f(7,0,-12);
gltexcoord2f(1,1);
glvertex3f(7,2,-12);
gltexcoord2f(0.375,1);
glvertex3f(7,2,-7);
glend;

gldisable(gl_blend);
glcolor3f(1,1,1);


wall2.bind;
gldepthmask(gl_false);
glbegin(gl_quads);               // Raum2 Wand Rechts
gltexcoord2f(0,0);
glvertex3f(15,0,-4);
gltexcoord2f(5,0);
glvertex3f(15,0,-12);
gltexcoord2f(5,1);
glvertex3f(15,2,-12);
gltexcoord2f(0,1);
glvertex3f(15,2,-4);
glend;
gldepthmask(gl_true);

glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.3,0.3,0.3);
light4.bind;
end
else
begin
glcolor3f(1,1,1);
light2.bind;
end;

glbegin(gl_quads);               // Raum2 Wand Rechts-Licht
gltexcoord2f(0,0);
glvertex3f(15,0,-4);
gltexcoord2f(1,0);
glvertex3f(15,0,-12);
gltexcoord2f(1,1);
glvertex3f(15,2,-12);
gltexcoord2f(0,1);
glvertex3f(15,2,-4);
glend;

gldisable(gl_blend);
glcolor3f(1,1,1);

top.bind;
gldepthmask(gl_false);
glbegin(gl_quads);
gltexcoord2f(0,0);           //Raum2 Decke
glvertex3f(7,2,-4);
gltexcoord2f(8,0);
glvertex3f(15,2,-4);
gltexcoord2f(8,8);
glvertex3f(15,2,-12);
gltexcoord2f(0,8);
glvertex3f(7,2,-12);
glend;
gldepthmask(gl_true);


glenable(gl_blend);
glblendfunc(gl_dst_color, gl_zero);
if lichtan=false then
begin
glcolor3f(0.3,0.3,0.3);
light4.bind;
end
else
begin
glcolor3f(1,1,1);
light1.bind;
end;

glbegin(gl_quads);
gltexcoord2f(0,0);           //Raum2 Decke-Licht
glvertex3f(7,2,-4);
gltexcoord2f(1,0);
glvertex3f(15,2,-4);
gltexcoord2f(1,1);
glvertex3f(15,2,-12);
gltexcoord2f(0,1);
glvertex3f(7,2,-12);
glend;
gldisable(gl_blend);

glcolor3f(1,1,1);

glpushmatrix;
gltranslate(11,0,-8);
wall1.bind;                        //Lampe3 (Raum2)
if lichtan = true then
begin
glcolor3f(0.8,0.8,0.8);
end
else
begin
glcolor3f(0.2,0.2,0.2);
end;
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,-0.25);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-0.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,-0.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,-0.25);

gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,0.25);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,0.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,0.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,0.25);

gltexcoord2f(0,0);
glvertex3f(-0.25,1.95,0.25);
gltexcoord2f(1,0);
glvertex3f(-0.25,1.95,-0.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,-0.25);
gltexcoord2f(1,1);
glvertex3f(-0.25,2,0.25);

gltexcoord2f(0,0);
glvertex3f(0.25,1.95,0.25);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-0.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,-0.25);
gltexcoord2f(1,1);
glvertex3f(0.25,2,0.25);
glend;

if lichtan = true then
begin
glcolor3f(0.8,0.8,0.8);
end
else
begin
glcolor3f(0.2,0.2,0.2);
end;

light.bind;
glbegin(gl_quads);
gltexcoord2f(0,0);
glvertex3f(0.25,1.95,0.25);
gltexcoord2f(1,0);
glvertex3f(0.25,1.95,-0.25);
gltexcoord2f(1,2);
glvertex3f(-0.25,1.95,-0.25);
gltexcoord2f(0,2);
glvertex3f(-0.25,1.95,0.25);
glend;
glpopmatrix;
end;


procedure render;
begin
glMatrixMode(GL_MODELVIEW);
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); //Farb und Tiefenpuffer lschen
glLoadIdentity;  

if rdir = 1 then
begin
rot := rot-5*timefactor;
end;

if rdir = 2 then
begin
rot := rot+5*timefactor;
end;

if getasynckeystate(vk_up) <> 0 then
begin
my_x := my_x-0.4*sin(degtorad(rot))*timefactor;
my_y := my_y+0.4*cos(degtorad(rot))*timefactor;
end;

if getasynckeystate(vk_down) <> 0 then
begin
my_x := my_x+0.4*sin(degtorad(rot))*timefactor;
my_y := my_y-0.4*cos(degtorad(rot))*timefactor;
end;

if getasynckeystate(vk_right) <> 0 then
begin
my_x := my_x+0.2*sin(degtorad(rot-90))*timefactor;
my_y := my_y-0.2*cos(degtorad(rot-90))*timefactor;
end;

if getasynckeystate(vk_left) <> 0 then
begin
my_x := my_x+0.2*sin(degtorad(rot+90))*timefactor;
my_y := my_y-0.2*cos(degtorad(rot+90))*timefactor;
end;
glcolor3f(1,1,1);

glinitnames;
glpushname(0);

glrotate(rot,0,1,0);
gltranslate(my_x,-1.1,my_y);

glloadname(umgebung);
draw_raum1;
glloadname(umgebung);
draw_verbindung;
glloadname(umgebung);
draw_raum2;

glloadname(schalter);
gldisable(gl_texture_2d);
glcolor3f(0.5,0.5,0.5);
glbegin(gl_quads);
glvertex3f(3.97,1.3,-3.9);
glvertex3f(3.97,1.3,-3.8);
glvertex3f(3.97,1.2,-3.8);
glvertex3f(3.97,1.2,-3.9);

glvertex3f(3.97,1.3,-3.9);
glvertex3f(4,1.3,-3.9);
glvertex3f(4,1.2,-3.9);
glvertex3f(3.97,1.2,-3.9);

glvertex3f(3.97,1.3,-3.8);
glvertex3f(4,1.3,-3.8);
glvertex3f(4,1.2,-3.8);
glvertex3f(3.97,1.2,-3.8);
glend;

if lichtan=true then
begin
glcolor3f(1,1,1);
end
else
begin
glcolor3f(1,1,0);
end;

glloadname(schalter);
glbegin(gl_quads);
glvertex3f(3.969,1.275,-3.875);
glvertex3f(3.969,1.275,-3.825);
glvertex3f(3.969,1.225,-3.825);
glvertex3f(3.969,1.225,-3.875); 
glend;

glcolor3f(1,1,1);

glenable(gl_texture_2d);

SwapBuffers(form1.myDC);                             //scene ausgeben
end;
function Selection : integer;
var
Puffer       : array[0..256] of GLUInt;
Viewport     : array[0..3] of Integer;
Treffer,i    : Integer;
Z_Wert       : GLUInt;
Getroffen    : GLUInt;
begin
glGetIntegerv(GL_VIEWPORT, @viewport);      //Die Sicht speichern
glSelectBuffer(256, @Puffer);               //Den Puffer zuordnen
glRenderMode(GL_SELECT);                    //In den Selectionsmodus schalten
glmatrixmode(gl_projection);                //In den Projektionsmodus
glPushMatrix;                               //Um unsere Matrix zu sichern
glLoadIdentity;                             //Und dieselbige wieder zurckzusetzen

gluPickMatrix(xs, viewport[3]-ys, 1.0, 1.0, @viewport);   
gluPerspective(45.0, form1.ClientWidth/form1.ClientHeight, 1, 100);

render;                                     //Die Szene zeichnen
glmatrixmode(gl_projection);                //Wieder in den Projektionsmodus
glPopMatrix;                                //um unsere alte Matrix wiederherzustellen

treffer := glRenderMode(GL_RENDER);         //Anzahl der Treffer auslesen

Getroffen := High(GLUInt);                  //Hchsten mglichen Wert annehmen
Z_Wert := High(GLUInt);                     //Hchsten Z - Wert
for i := 0 to Treffer-1 do                   
if Puffer[(i*4)+1] < Z_Wert then
 begin
 getroffen       := Puffer[(i*4)+3];
 Z_Wert := Puffer[(i*4)+1];
 end;

 Result := getroffen;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
form1.myDC:= GetDC(Handle);
SetupPixelFormat;
myRC:= wglCreateContext(myDC);
wglMakeCurrent(myDC, myRC);
glEnable(GL_DEPTH_TEST);
glLoadIdentity;
glenable(gl_texture_2d);
inittextures;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
wglmakecurrent(0,0);
wgldeletecontext(mydc);
releasedc(handle,mydc);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
glViewport(0, 0, form1.clientWidth, form1.clientHeight);    // Setzt den Viewport fr das OpenGL Fenster
glMatrixMode(GL_PROJECTION);        // Matrix Mode auf Projection setzen
glLoadIdentity();                   // Reset View
gluPerspective(45.0, form1.clientWidth/form1.clientHeight, 1, 100.0);  // Perspektive den neuen Maen anpassen.
glMatrixMode(GL_MODELVIEW);         // Zurck zur Modelview Matrix
glLoadIdentity();
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
render;
fps := fps+1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

rdir := 0;

if x < 50 then
begin
rdir := 1;
end;

if x > form1.clientwidth-50 then
begin
rdir := 2;
end;


end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
if fps=0 then
begin
fps := 1;
end;
timefactor := 20/fps;
fps := 0;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
xdis : double;
ydis : double;
begin
xdis := my_x+4;
ydis := my_y-3.85;

xs := x;
ys := y;

if selection=1 then
begin
 if sqrt(xdis*xdis + ydis*ydis) <= 3 then
 lichtan := not lichtan;
end;

end;

end.
